package rocks.zipcode.io.quiz3.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 09/12/2018.
 */
public class PigLatinGenerator {
    public String translate(String str) {
        String latin = "";
        int i = 0;
        while (i<str.length()) {

            // Take care of punctuation and spaces
            while (i<str.length() && !isLetter(str.charAt(i))) {
                latin = latin + str.charAt(i);
                i++;
            }

            // If there aren't any words left, stop.
            if (i>=str.length()) break;

            // Otherwise we're at the beginning of a word.
            int begin = i;
            while (i<str.length() && isLetter(str.charAt(i))) {
                i++;
            }

            // Now we're at the end of a word, so translate it.
            int end = i;
            latin = latin + pigWord(str.substring(begin, end));
        }
        return latin;
    }

    private static boolean isLetter(char c) {
        return ( (c >='A' && c <='Z') || (c >='a' && c <='z') );
    }

    private static String pigWord(String word) {
        int split = firstVowel(word);
        return word.substring(split)+word.substring(0, split)+"ay";
    }
    private static int firstVowel(String word) {
        word = word.toLowerCase();
        for (int i=0; i<word.length(); i++)
            if (word.charAt(i)=='a' || word.charAt(i)=='e' ||
                    word.charAt(i)=='i' || word.charAt(i)=='o' ||
                    word.charAt(i)=='u')
                return i;
        return 0;
    }
}

